--------------------------------------------------------------------------------
-- oUF_Banzai
--
-- Colors oUF health bars red when the unit has aggro.
-- Disabled for target, targettarget and targettargettarget.
--
-- If you wish to exclude your frame from being colored, set 'ignoreBanzai' to
-- any non-nil value.
-- i.e.:
--   self.ignoreBanzai = true
-- 
--------------------------------------------------------------------------------

if not oUF then return end

local banzai = LibStub("LibBanzai-2.0")

local ignoredUnits = {
	target = true,
	targettarget = true,
	targettargettarget = true,
}

local function applyBanzai(frame, event, bar, unit, min, max)
	if not ignoredUnits[unit] and banzai:GetUnitAggroByUnitId(unit) then
		bar:SetStatusBarColor(1, 0, 0)
	end
end

local function hook(frame)
	if frame.ignoreBanzai then return end
	local o = frame.PostUpdateHealth
	frame.PostUpdateHealth = function(...)
		if o then o(...) end
		applyBanzai(...)
	end
end
for frame in pairs(oUF.objects) do hook(frame) end
oUF:RegisterInitCallback(hook)

banzai:RegisterCallback(function(aggro, name, ...)
	for i = 1, select("#", ...) do
		local u = select(i, ...)
		if not ignoredUnits[u] and oUF.units[u] and not oUF.units[u].ignoreBanzai then
			if aggro == 1 then
				oUF.units[u].Health:SetStatusBarColor(1, 0, 0)
			else
				oUF.units[u]:UNIT_HEALTH(nil, u)
			end
		end
	end
end)

